package mjc.egg;
import mjc.compiler.*;
import mjc.gc.*;
import mjc.lib.*;
import mjc.lib.type.*;
import mjc.lib.classe.*;
import mg.egg.eggc.compiler.libjava.lex.*;
import mg.egg.eggc.compiler.libjava.*;
import mg.egg.eggc.compiler.libjava.problem.IProblem;
import java.util.Vector;
public class S_INST_MJAVA {
LEX_MJAVA scanner;
  S_INST_MJAVA() {
    }
  S_INST_MJAVA(LEX_MJAVA scanner) {
    this.scanner = scanner;
    this.att_scanner = scanner;
    }
int [] sync= new int[0];
  int att_depl;
  CLASSE att_classe;
  int att_s_depl;
  METHODE att_meth;
  int att_hasReturn;
  TDC att_tdc;
  DTYPE att_htype;
  String att_code;
  LPARAMS att_params;
  AbstractMachine att_machine;
  TDS att_tds;
  LEX_MJAVA att_scanner;
  VARIABLE glob_23_i;
  private void regle26() throws Exception {

    //declaration
    S_BLOC_MJAVA x_2 = new S_BLOC_MJAVA(scanner) ;
    //appel
      action_auto_inh_26(x_2);
    x_2.analyser() ;
      action_return_26(x_2);
      action_depl_26(x_2);
      action_code_26(x_2);
  }
  private void regle27() throws Exception {

    //declaration
    T_MJAVA x_2 = new T_MJAVA(scanner ) ;
    T_MJAVA x_3 = new T_MJAVA(scanner ) ;
    S_E_MJAVA x_4 = new S_E_MJAVA(scanner) ;
    T_MJAVA x_6 = new T_MJAVA(scanner ) ;
    S_BLOC_MJAVA x_7 = new S_BLOC_MJAVA(scanner) ;
    S_SIX_MJAVA x_8 = new S_SIX_MJAVA(scanner) ;
    //appel
      action_auto_inh_27(x_4, x_7, x_8);
    x_2.analyser(LEX_MJAVA.token_si);
    x_3.analyser(LEX_MJAVA.token_paro);
    x_4.analyser() ;
      action_type_27(x_4, x_7, x_8);
    x_6.analyser(LEX_MJAVA.token_parf);
    x_7.analyser() ;
    x_8.analyser() ;
      action_depl_27(x_4, x_7, x_8);
      action_return_27(x_4, x_7, x_8);
      action_gen_27(x_4, x_7, x_8);
  }
  private void regle24() throws Exception {

    //declaration
    S_E_MJAVA x_2 = new S_E_MJAVA(scanner) ;
    T_MJAVA x_3 = new T_MJAVA(scanner ) ;
    //appel
      action_auto_inh_24(x_2);
    x_2.analyser() ;
    x_3.analyser(LEX_MJAVA.token_pv);
      action_return_24(x_2);
      action_depl_24(x_2);
      action_gen_24(x_2);
  }
  private void regle25() throws Exception {

    //declaration
    T_MJAVA x_2 = new T_MJAVA(scanner ) ;
    S_E_MJAVA x_3 = new S_E_MJAVA(scanner) ;
    T_MJAVA x_4 = new T_MJAVA(scanner ) ;
    //appel
      action_auto_inh_25(x_3);
    x_2.analyser(LEX_MJAVA.token_print);
    x_3.analyser() ;
    x_4.analyser(LEX_MJAVA.token_pv);
      action_return_25(x_3);
      action_depl_25(x_3);
      action_gen_25(x_3);
  }
  private void regle30() throws Exception {

    //declaration
    T_MJAVA x_2 = new T_MJAVA(scanner ) ;
    S_E_MJAVA x_3 = new S_E_MJAVA(scanner) ;
    T_MJAVA x_5 = new T_MJAVA(scanner ) ;
    //appel
      action_auto_inh_30(x_3);
    x_2.analyser(LEX_MJAVA.token_retour);
    x_3.analyser() ;
      action_type_30(x_3);
    x_5.analyser(LEX_MJAVA.token_pv);
      action_depl_30(x_3);
      action_return_30(x_3);
      action_gen_30(x_3);
  }
  private void regle31() throws Exception {

    //declaration
    T_MJAVA x_2 = new T_MJAVA(scanner ) ;
    T_MJAVA x_3 = new T_MJAVA(scanner ) ;
    S_E_MJAVA x_4 = new S_E_MJAVA(scanner) ;
    T_MJAVA x_6 = new T_MJAVA(scanner ) ;
    S_BLOC_MJAVA x_7 = new S_BLOC_MJAVA(scanner) ;
    //appel
      action_auto_inh_31(x_4, x_7);
    x_2.analyser(LEX_MJAVA.token_tantque);
    x_3.analyser(LEX_MJAVA.token_paro);
    x_4.analyser() ;
      action_type_31(x_4, x_7);
    x_6.analyser(LEX_MJAVA.token_parf);
    x_7.analyser() ;
      action_depl_31(x_4, x_7);
      action_return_31(x_4, x_7);
      action_gen_31(x_4, x_7);
  }
  private void regle23() throws Exception {

    //declaration
    S_TYPE_MJAVA x_2 = new S_TYPE_MJAVA(scanner) ;
    T_MJAVA x_3 = new T_MJAVA(scanner ) ;
    S_AFFX_MJAVA x_5 = new S_AFFX_MJAVA(scanner) ;
    T_MJAVA x_6 = new T_MJAVA(scanner ) ;
    //appel
      action_auto_inh_23(x_2, x_3, x_5);
    x_2.analyser() ;
    x_3.analyser(LEX_MJAVA.token_ident);
      action_tds_23(x_2, x_3, x_5);
    x_5.analyser() ;
    x_6.analyser(LEX_MJAVA.token_pv);
      action_return_23(x_2, x_3, x_5);
      action_depl_23(x_2, x_3, x_5);
      action_code_23(x_2, x_3, x_5);
  }
private void action_type_30(S_E_MJAVA x_3) throws Exception {
try {
// instructions
if (!(x_3.att_type.compareTo(this.att_htype))){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_return_type_mismatch, MJAVAMessages.M_return_type_mismatch,new Object[]{""+x_3.att_type.getNom(), ""+this.att_htype.getNom()});

}

}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_type_31(S_E_MJAVA x_4, S_BLOC_MJAVA x_7) throws Exception {
try {
// instructions
if ((!(x_4.att_type.compareTo( new BOOLEEN())))){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_decl_type_mismatch_error, MJAVAMessages.M_decl_type_mismatch_error,new Object[]{""+x_4.att_type.getNom(), ""+"booleen"});

}

}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_27(S_E_MJAVA x_4, S_BLOC_MJAVA x_7, S_SIX_MJAVA x_8) throws Exception {
try {
// instructions
x_4.att_tdc=this.att_tdc;
x_7.att_tdc=this.att_tdc;
x_8.att_tdc=this.att_tdc;
x_4.att_classe=this.att_classe;
x_7.att_classe=this.att_classe;
x_8.att_classe=this.att_classe;
x_7.att_htype=this.att_htype;
x_8.att_htype=this.att_htype;
x_4.att_params=this.att_params;
x_7.att_params=this.att_params;
x_8.att_params=this.att_params;
x_4.att_tds=this.att_tds;
x_7.att_tds=this.att_tds;
x_8.att_tds=this.att_tds;
x_4.att_meth=this.att_meth;
x_7.att_meth=this.att_meth;
x_8.att_meth=this.att_meth;
x_4.att_machine=this.att_machine;
x_7.att_machine=this.att_machine;
x_8.att_machine=this.att_machine;
x_7.att_depl=this.att_depl;
x_8.att_depl=this.att_depl;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_26(S_BLOC_MJAVA x_2) throws Exception {
try {
// instructions
x_2.att_tdc=this.att_tdc;
x_2.att_classe=this.att_classe;
x_2.att_htype=this.att_htype;
x_2.att_params=this.att_params;
x_2.att_tds=this.att_tds;
x_2.att_meth=this.att_meth;
x_2.att_machine=this.att_machine;
x_2.att_depl=this.att_depl;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_25(S_E_MJAVA x_3) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_24(S_E_MJAVA x_2) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_27(S_E_MJAVA x_4, S_BLOC_MJAVA x_7, S_SIX_MJAVA x_8) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_26(S_BLOC_MJAVA x_2) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_27(S_E_MJAVA x_4, S_BLOC_MJAVA x_7, S_SIX_MJAVA x_8) throws Exception {
try {
// instructions
if ((x_8.att_hasReturn!=-1)){
this.att_hasReturn=x_7.att_hasReturn/x_8.att_hasReturn;
}
else {
this.att_hasReturn=0;
}
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_26(S_BLOC_MJAVA x_2) throws Exception {
try {
// instructions
this.att_hasReturn=x_2.att_hasReturn;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_25(S_E_MJAVA x_3) throws Exception {
try {
// instructions
this.att_hasReturn=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_24(S_E_MJAVA x_2) throws Exception {
try {
// instructions
this.att_hasReturn=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_23(S_TYPE_MJAVA x_2, T_MJAVA x_3, S_AFFX_MJAVA x_5) throws Exception {
try {
// instructions
this.att_s_depl=x_2.att_type.getTaille();
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_23(S_TYPE_MJAVA x_2, T_MJAVA x_3, S_AFFX_MJAVA x_5) throws Exception {
try {
// instructions
this.att_hasReturn=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_code_23(S_TYPE_MJAVA x_2, T_MJAVA x_3, S_AFFX_MJAVA x_5) throws Exception {
try {
// instructions
if ((!(x_5.att_code.equals("")))){
this.att_code=x_5.att_code;
}
else {
this.att_code=this.att_machine.genDecl(glob_23_i);
}
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_30(S_E_MJAVA x_3) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_gen_30(S_E_MJAVA x_3) throws Exception {
try {
// instructions
this.att_code=x_3.att_code+this.att_machine.genRetour(this.att_meth, this.att_tds);
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_gen_31(S_E_MJAVA x_4, S_BLOC_MJAVA x_7) throws Exception {
try {
// instructions
this.att_code=this.att_machine.genTq(x_4.att_code, x_7.att_code);
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_code_26(S_BLOC_MJAVA x_2) throws Exception {
try {
// instructions
this.att_code=x_2.att_code+this.att_machine.genFree(x_2.att_s_depl);
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_24(S_E_MJAVA x_2) throws Exception {
try {
// instructions
x_2.att_tdc=this.att_tdc;
x_2.att_classe=this.att_classe;
x_2.att_params=this.att_params;
x_2.att_tds=this.att_tds;
x_2.att_meth=this.att_meth;
x_2.att_machine=this.att_machine;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_25(S_E_MJAVA x_3) throws Exception {
try {
// instructions
x_3.att_tdc=this.att_tdc;
x_3.att_classe=this.att_classe;
x_3.att_params=this.att_params;
x_3.att_tds=this.att_tds;
x_3.att_meth=this.att_meth;
x_3.att_machine=this.att_machine;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_23(S_TYPE_MJAVA x_2, T_MJAVA x_3, S_AFFX_MJAVA x_5) throws Exception {
try {
// instructions
x_2.att_tdc=this.att_tdc;
x_5.att_tdc=this.att_tdc;
x_5.att_classe=this.att_classe;
x_5.att_params=this.att_params;
x_5.att_tds=this.att_tds;
x_5.att_meth=this.att_meth;
x_5.att_machine=this.att_machine;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_type_27(S_E_MJAVA x_4, S_BLOC_MJAVA x_7, S_SIX_MJAVA x_8) throws Exception {
try {
// instructions
if ((!(x_4.att_type.compareTo( new BOOLEEN())))){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_decl_type_mismatch_error, MJAVAMessages.M_decl_type_mismatch_error,new Object[]{""+x_4.att_type.getNom(), ""+"booleen"});

}

}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_gen_24(S_E_MJAVA x_2) throws Exception {
try {
// instructions
this.att_code=x_2.att_code;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_tds_23(S_TYPE_MJAVA x_2, T_MJAVA x_3, S_AFFX_MJAVA x_5) throws Exception {
try {
// locales
PARAM loc_a;
PARAM loc_p;
LPARAMS loc_ats;
// instructions
x_5.att_htype=x_2.att_type;
glob_23_i=this.att_tds.chercherLocalement(x_3.att_txt);
loc_ats=this.att_classe.getAttributs();
loc_a=loc_ats.chercher(x_3.att_txt);
loc_p=this.att_params.chercher(x_3.att_txt);
if (glob_23_i!=null){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_already_defined_var, MJAVAMessages.M_already_defined_var,new Object[]{""+x_3.att_txt});

}
else if (loc_a!=null){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_ident_used_attr, MJAVAMessages.M_ident_used_attr,new Object[]{""+x_3.att_txt});

}
else if (loc_p!=null){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_already_defined_param, MJAVAMessages.M_already_defined_param,new Object[]{""+x_3.att_txt});

}
else {
glob_23_i= new VARIABLE(x_2.att_type, this.att_depl);
    this.att_tds.inserer(x_3.att_txt, glob_23_i);
}
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_gen_25(S_E_MJAVA x_3) throws Exception {
try {
// instructions
this.att_code=this.att_machine.genAffichage(x_3.att_code, x_3.att_type);
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_gen_27(S_E_MJAVA x_4, S_BLOC_MJAVA x_7, S_SIX_MJAVA x_8) throws Exception {
try {
// instructions
this.att_code=this.att_machine.genSi(x_4.att_code, x_7.att_code, x_8.att_code);
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_depl_31(S_E_MJAVA x_4, S_BLOC_MJAVA x_7) throws Exception {
try {
// instructions
this.att_s_depl=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_30(S_E_MJAVA x_3) throws Exception {
try {
// locales
DTYPE loc_t;
// instructions
loc_t=this.att_meth.getType();
this.att_hasReturn=1;
if ((loc_t!=null)){
if (loc_t instanceof VIDE ){
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_invalid_return, MJAVAMessages.M_invalid_return,new Object[]{""+this.att_meth.getNom()});

}

}
else {
att_scanner._interrompre(IProblem.Semantic, att_scanner.getBeginLine(), IMJAVAMessages.id_M_return_const, MJAVAMessages.M_return_const,new Object[]{""+this.att_meth.getNom()});

}
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_return_31(S_E_MJAVA x_4, S_BLOC_MJAVA x_7) throws Exception {
try {
// instructions
this.att_hasReturn=0;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_30(S_E_MJAVA x_3) throws Exception {
try {
// instructions
x_3.att_tdc=this.att_tdc;
x_3.att_classe=this.att_classe;
x_3.att_params=this.att_params;
x_3.att_tds=this.att_tds;
x_3.att_meth=this.att_meth;
x_3.att_machine=this.att_machine;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
private void action_auto_inh_31(S_E_MJAVA x_4, S_BLOC_MJAVA x_7) throws Exception {
try {
// instructions
x_4.att_tdc=this.att_tdc;
x_7.att_tdc=this.att_tdc;
x_4.att_classe=this.att_classe;
x_7.att_classe=this.att_classe;
x_7.att_htype=this.att_htype;
x_4.att_params=this.att_params;
x_7.att_params=this.att_params;
x_4.att_tds=this.att_tds;
x_7.att_tds=this.att_tds;
x_4.att_meth=this.att_meth;
x_7.att_meth=this.att_meth;
x_4.att_machine=this.att_machine;
x_7.att_machine=this.att_machine;
x_7.att_depl=this.att_depl;
}catch(RuntimeException e) {		//e.printStackTrace();
	}
  }
  public void analyser () throws Exception {
    scanner.lit ( 1 ) ;
    switch ( scanner.fenetre[0].code ) {
      case LEX_MJAVA.token_int : // 129
        regle23 () ;
      break ;
      case LEX_MJAVA.token_bool : // 130
        regle23 () ;
      break ;
      case LEX_MJAVA.token_ident : // 160
        scanner.lit ( 2 ) ;
        switch ( scanner.fenetre[1].code ) {
          case LEX_MJAVA.token_ident : // 160
            regle23 () ;
          break ;
          case LEX_MJAVA.token_pt : // 123
            regle24 () ;
          break ;
          case LEX_MJAVA.token_paro : // 115
            regle24 () ;
          break ;
          case LEX_MJAVA.token_mult : // 149
            regle24 () ;
          break ;
          case LEX_MJAVA.token_div : // 150
            regle24 () ;
          break ;
          case LEX_MJAVA.token_mod : // 151
            regle24 () ;
          break ;
          case LEX_MJAVA.token_et : // 152
            regle24 () ;
          break ;
          case LEX_MJAVA.token_plus : // 146
            regle24 () ;
          break ;
          case LEX_MJAVA.token_moins : // 147
            regle24 () ;
          break ;
          case LEX_MJAVA.token_ou : // 148
            regle24 () ;
          break ;
          case LEX_MJAVA.token_inf : // 140
            regle24 () ;
          break ;
          case LEX_MJAVA.token_infeg : // 141
            regle24 () ;
          break ;
          case LEX_MJAVA.token_sup : // 142
            regle24 () ;
          break ;
          case LEX_MJAVA.token_supeg : // 143
            regle24 () ;
          break ;
          case LEX_MJAVA.token_eg : // 144
            regle24 () ;
          break ;
          case LEX_MJAVA.token_neg : // 145
            regle24 () ;
          break ;
          case LEX_MJAVA.token_affect : // 124
            regle24 () ;
          break ;
          case LEX_MJAVA.token_pv : // 122
            regle24 () ;
          break ;
          default :
                   scanner._interrompre(IProblem.Syntax, scanner.getBeginLine(), IMJAVAMessages.id_MJAVA_unexpected_token,MJAVAMessages.MJAVA_unexpected_token,new String[]{scanner.fenetre[1].getNom()});
scanner.accepter_sucre(LEX_MJAVA.token_ident);
        }
      break ;
      case LEX_MJAVA.token_entier : // 159
        regle24 () ;
      break ;
      case LEX_MJAVA.token_vrai : // 154
        regle24 () ;
      break ;
      case LEX_MJAVA.token_faux : // 155
        regle24 () ;
      break ;
      case LEX_MJAVA.token_plus : // 146
        regle24 () ;
      break ;
      case LEX_MJAVA.token_moins : // 147
        regle24 () ;
      break ;
      case LEX_MJAVA.token_non : // 153
        regle24 () ;
      break ;
      case LEX_MJAVA.token_null : // 139
        regle24 () ;
      break ;
      case LEX_MJAVA.token_paro : // 115
        regle24 () ;
      break ;
      case LEX_MJAVA.token_nouveau : // 134
        regle24 () ;
      break ;
      case LEX_MJAVA.token_print : // 158
        regle25 () ;
      break ;
      case LEX_MJAVA.token_aco : // 117
        regle26 () ;
      break ;
      case LEX_MJAVA.token_si : // 125
        regle27 () ;
      break ;
      case LEX_MJAVA.token_retour : // 133
        regle30 () ;
      break ;
      case LEX_MJAVA.token_tantque : // 127
        regle31 () ;
      break ;
      default :
               scanner._interrompre(IProblem.Syntax, scanner.getBeginLine(), IMJAVAMessages.id_MJAVA_unexpected_token,MJAVAMessages.MJAVA_unexpected_token,new String[]{scanner.fenetre[0].getNom()});
    }
  }
  }
