package mjc.lib.classe;

import mjc.lib.type.DTYPE;

public class PARAM {

	protected String nom;
	protected DTYPE type;
	protected int deplacement;
	
	public PARAM(String n, DTYPE t, int dep){
		this.nom  = n;
		this.type = t;
		this.deplacement = dep;
	}
	
	public String getNom(){
		return this.nom;
	}
	
	public DTYPE getType(){
		return this.type;
	}
	
	public boolean equals(Object o){
		if (o instanceof PARAM) {
			return type.equals(((PARAM) o).type);
		}
		
		return false;
	}
	
	public String toString() {
		return nom + " ; type=" + type + " dep=" + deplacement; 
	}

	public int getDeplacement() {
		return deplacement;
	}
	
}
